// -*- mode: js; js-indent-level: 4; indent-tabs-mode: nil -*-

const AltTab = imports.ui.altTab;

var _originalFunction = [];

var windowCount;

function windowList_init(windows, mode)
{
    let workspace = global.screen.get_active_workspace();

    let windowsCurrent = windows.filter(window => window.get_workspace() == workspace);
    let windowsOther = windows.filter(window => window.get_workspace() != workspace);

    windowCount = windowsCurrent.length;

    _originalFunction['windowList_init'].apply(this, [windowsCurrent.concat(windowsOther), mode]);
};

function windowList_highlight(index, justOutline)
{
    _originalFunction['windowList_highlight'].apply(this, [index, justOutline]);

    this._label.remove_style_class_name(index < windowCount ? 'alt-tab-app-other' : 'alt-tab-app-current');
    this._label.add_style_class_name(index < windowCount ? 'alt-tab-app-current' : 'alt-tab-app-other');
};

function enable()
{
    _originalFunction['windowList_init'] = AltTab.WindowList.prototype._init;
    AltTab.WindowList.prototype._init = windowList_init;
    _originalFunction['windowList_highlight'] = AltTab.WindowList.prototype.highlight;
    AltTab.WindowList.prototype.highlight = windowList_highlight;
}

function disable()
{
    AltTab.WindowList.prototype._init = _originalFunction['windowList_init'];
    AltTab.WindowList.prototype.highlight = _originalFunction['windowList_highlight'];
}
